Imports System.Windows.Forms
Imports System.Drawing
Imports System.Drawing.Drawing2D
Public Class DummyGrid
    Inherits Control
    Private AL As New ArrayList()
    Private _Bitmap As Bitmap

    Public Sub New()
        MyBase.New()
        SetStyle(ControlStyles.DoubleBuffer, True)
        SetStyle(ControlStyles.UserPaint, True)
        SetStyle(ControlStyles.AllPaintingInWmPaint, True)

        Me.BackColor = Color.White
    End Sub

    Private Sub DrawControl(ByVal graphics As Graphics)
        Dim g As Graphics = Nothing
        Dim I As Integer
        If IsNothing(_Bitmap) Then
            _Bitmap = New Bitmap(Me.Width, Me.Height)
            g = Drawing.Graphics.FromImage(_Bitmap)
            Try

                Dim LinePen As New Pen(Color.DarkBlue)
                For I = 0 To Me.ClientRectangle.Width \ 50
                    g.DrawLine(LinePen, I * 50, 0, I * 50, Me.ClientRectangle.Height)
                Next
                For I = 0 To Me.ClientRectangle.Height \ 20
                    g.DrawLine(LinePen, 0, I * 20, Me.ClientRectangle.Width, I * 20)
                Next
                LinePen.Dispose()

                ControlPaint.DrawBorder3D(g, Me.ClientRectangle, Border3DStyle.Sunken)

            Catch ex As Exception
                System.Diagnostics.Debug.WriteLine(ex.Message)
            Finally
                g.Dispose()
            End Try
        End If
        g = graphics
        Try
            g.DrawImage(_Bitmap, Me.ClientRectangle)
        Catch ex As Exception
            System.Diagnostics.Debug.WriteLine(ex.Message)
        Finally
            GC.Collect()
        End Try
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        DrawControl(e.Graphics)
    End Sub
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)
        _Bitmap = Nothing
        Invalidate()
    End Sub
    Public Overrides Sub Refresh()
        MyBase.Refresh()
        Me.Invalidate()
    End Sub

End Class
