Public Class VisibleDragControls

#Region " Variables/Events "

    Public Ctls As New ArrayList()
    Public SourceControlNr As Integer
    Public ActiveControlNr As Integer
    Public PreviousControlNr As Integer

    Private InfoBoxExclude As InfoBox
    Private InfoBoxField As InfoBox
    Private InfoBoxCol0 As InfoBox
    Private InfoBoxCol1 As InfoBox
    Private InfoBoxRow0 As InfoBox
    Private InfoBoxRow1 As InfoBox
    Private InfoParkBox As InfoParkBox
    Private Treeview As Treeview
    Private WithEvents TestForm As TestForm

    Private DragBox As InfoBox

    Private ControlPos(0, 0) As Integer
    Private xIndizes(0) As Integer
    Private yIndizes(0) As Integer
    Private UBx, UBy As Integer

    Private PreferredDragSize As Size = New Size(184, 48)

    Public Event DataChanged()

#End Region


    Public Sub New(ByVal xInfoBoxExclude As InfoBox, ByVal xInfoBoxField As InfoBox, ByVal xInfoBoxRow0 As InfoBox, _
    ByVal xInfoBoxRow1 As InfoBox, ByVal xInfoBoxCol0 As InfoBox, ByVal xInfoBoxCol1 As InfoBox, _
    ByVal xInfoParkBox As InfoParkBox, ByVal xTreeview As Treeview, ByVal xTestForm As TestForm)

        InfoBoxExclude = xInfoBoxExclude
        InfoBoxExclude.BoxNumber = 0
        Ctls.Add(InfoBoxExclude)
        InfoBoxField = xInfoBoxField
        InfoBoxField.BoxNumber = 1
        Ctls.Add(InfoBoxField)
        InfoBoxCol0 = xInfoBoxCol0
        InfoBoxCol0.BoxNumber = 2
        Ctls.Add(InfoBoxCol0)
        InfoBoxCol1 = xInfoBoxCol1
        InfoBoxCol1.BoxNumber = 3
        Ctls.Add(InfoBoxCol1)
        InfoBoxRow0 = xInfoBoxRow0
        InfoBoxRow0.BoxNumber = 4
        Ctls.Add(InfoBoxRow0)
        InfoBoxRow1 = xInfoBoxRow1
        InfoBoxRow1.BoxNumber = 5
        Ctls.Add(InfoBoxRow1)
        InfoParkBox = xInfoParkBox
        InfoParkBox.BoxNumber = 6
        Ctls.Add(InfoParkBox)
        Treeview = xTreeview
        Ctls.Add(Treeview)

        TestForm = xTestForm
        GetControlPositions()

        DragBox = TestForm.DragBox
    End Sub


#Region " Code for Control Selection and Data Transfer "

    Public Sub SetMousePosition(ByVal mousepos As Point)

        Dim testnr As Integer = GetControlIndex_by_Mousepos(mousepos)
        If ActiveControlNr <> testnr Then
            PreviousControlNr = ActiveControlNr
            ActiveControlNr = testnr
            Dim S As Size
            If ActiveControlNr < 6 Then
                Dim x As InfoBox = Ctls.Item(ActiveControlNr)
                S = x.ActSize
            ElseIf ActiveControlNr = 6 Then
                S = InfoParkBox.ActSize
            Else
                S = PreferredDragSize
            End If
            DragBox.Size = S
            SetNewSelection()
            TestForm.DragControlInfo = "Dragging from " & GetControlName(SourceControlNr) & " to " & GetControlName(ActiveControlNr)
        End If

        Dim p1 As Point = mousepos
        p1.X -= DragBox.Size.Width \ 2
        p1.Y -= DragBox.Size.Height \ 2
        DragBox.Location = p1

    End Sub



    Public Sub OnDragboxMouseUp()
        If ActiveControlNr < 8 Then
            If MovingAllowed() = True Then
                TransferData()
                RaiseEvent DataChanged()
            Else
                CancelTransfer()
            End If
        Else
            CancelTransfer()
        End If
    End Sub

    Private Sub SetNewSelection()
        TestForm.SetSelection(ActiveControlNr)
        'ActiveControlNr 100 = TestForm Surface
        If ActiveControlNr < 7 Then
            If MovingAllowed() = False Then
                DragBox.SelectionMode = ContentDisplayModes.forbidden
            Else
                DragBox.SelectionMode = ContentDisplayModes.dragging
            End If
        Else
            DragBox.SelectionMode = ContentDisplayModes.dragging
        End If
    End Sub

    Private Sub TransferData()
        Select Case ActiveControlNr
            Case 6, 7
                InfoParkBox.InsertNode(DragBox.usedNode)
            Case Else
                Dim Ib As InfoBox = CType(Ctls.Item(ActiveControlNr), InfoBox)
                If Ib.DataAvailable Then
                    If SourceControlNr < 6 Then
                        Dim xIB As InfoBox = CType(Ctls.Item(SourceControlNr), InfoBox)
                        xIB.InsertNode(Ib.usedNode)
                    Else
                        InfoParkBox.InsertNode(Ib.usedNode)
                    End If
                End If
                Ib.InsertNode(DragBox.usedNode)
        End Select
        DragBox.RemoveNode()
    End Sub
    Private Function MovingAllowed() As Boolean
        Dim Res As Boolean = True
        If ActiveControlNr = 6 Then
            If Not InfoParkBox.Enabled Then Res = False
        ElseIf ActiveControlNr < 6 Then
            Dim x As InfoBox = CType(Ctls(ActiveControlNr), InfoBox)
            If Not x.Enabled Then Res = False
        End If
        Return Res
    End Function
    Private Sub CancelTransfer()
        Select Case SourceControlNr
            Case 6
                InfoParkBox.InsertNode(DragBox.usedNode)
                TestForm.SetSelection(SourceControlNr)
            Case Is < 6
                Dim pnl As InfoBox = CType(Ctls.Item(SourceControlNr), InfoBox)
                pnl.InsertNode(DragBox.usedNode)
                TestForm.SetSelection(SourceControlNr)
        End Select
    End Sub

#End Region

#Region " Code to set/get an Index for used Controls "

    Private Sub GetControlPositions()
        Dim ALx As New ArrayList()
        Dim ALy As New ArrayList()
        Dim c As Control
        Dim I, J, Counter As Integer

        For Each c In Ctls
            If ALx.Count = 0 Then
                ALx.Add(c.Left)
                ALy.Add(c.Top)
                ALx.Add(c.Left + c.Width)
                ALy.Add(c.Top + c.Height)
            Else
                If Not ALx.Contains(c.Left) Then
                    ALx.Add(c.Left)
                End If
                If Not ALx.Contains(c.Left + c.Width) Then
                    ALx.Add(c.Left + c.Width)
                End If
                If Not ALy.Contains(c.Top) Then
                    ALy.Add(c.Top)
                End If
                If Not ALy.Contains(c.Top + c.Height) Then
                    ALy.Add(c.Top + c.Height)
                End If
            End If
        Next
        ALx.Sort()
        ALy.Sort()
        ReDim xIndizes(ALx.Count - 1)
        ReDim yIndizes(ALy.Count - 1)
        ReDim ControlPos(ALx.Count - 2, ALy.Count - 2)

        For I = 0 To ALx.Count - 1
            xIndizes(I) = ALx.Item(I)
        Next
        UBx = ALx.Count - 1
        For I = 0 To ALy.Count - 1
            yIndizes(I) = ALy.Item(I)
        Next
        UBy = ALy.Count - 1
        For I = 0 To ALx.Count - 2
            For J = 0 To ALy.Count - 2
                ControlPos(I, J) = 100
            Next
        Next

        Dim l, r, o, u As Integer
        Counter = 0
        Dim xin As String
        For Each c In Ctls
            xin = c.Name
            For I = 0 To ALx.Count - 2
                If c.Left = xIndizes(I) Then
                    l = I
                End If
                If c.Left + c.Width = xIndizes(I + 1) Then
                    r = I
                    Exit For
                End If
            Next
            For I = 0 To ALy.Count - 2
                If c.Top = yIndizes(I) Then
                    o = I
                End If
                If c.Top + c.Height = yIndizes(I + 1) Then
                    u = I
                    Exit For
                End If
            Next
            For I = l To r
                For J = o To u
                    ControlPos(I, J) = Counter
                Next
            Next
            Counter += 1
        Next
    End Sub
    Public Function GetControlIndex_by_Mousepos(ByVal pt As Point) As Integer
        Dim Res As Integer = 100
        Dim a, x1, y1 As Integer
        x1 = -1
        y1 = -1
        For a = 0 To UBx - 1
            If xIndizes(a) <= pt.X Then
                If xIndizes(a + 1) >= pt.X Then
                    x1 = a
                    Exit For
                End If
            End If
        Next
        For a = 0 To UBy - 1
            If yIndizes(a) <= pt.Y Then
                If yIndizes(a + 1) >= pt.Y Then
                    y1 = a
                    Exit For
                End If
            End If
        Next
        If (x1 > -1) And y1 > -1 Then
            Res = ControlPos(x1, y1)
        End If
        Return Res
    End Function
    'only used for this example
    Private Function GetControlName(ByVal x As Integer) As String
        Dim CtrName As String
        Select Case x
            Case 0 : CtrName = "InfoBoxExclude"
            Case 1 : CtrName = "InfoBoxField"
            Case 2 : CtrName = "InfoBoxCol0"
            Case 3 : CtrName = "InfoBoxCol1"
            Case 4 : CtrName = "InfoBoxRow0"
            Case 5 : CtrName = "InfoBoxRow1"
            Case 6 : CtrName = "InfoParkBox"
            Case 7 : CtrName = "Treeview"
            Case Else : CtrName = "Form"
        End Select
        Return CtrName
    End Function
    Private Sub TestForm_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TestForm.SizeChanged
        GetControlPositions()
    End Sub

#End Region

End Class